$(function() {
  expandNavOnLowResolutions();
  

  $.widget( "custom.iconselectmenu", $.ui.selectmenu, {
    _renderItem: function(ul, item) {
      var li = $("<li>"),
      wrapper = $("<div>", {text: item.label});

      if (item.disabled) {
        li.addClass("ui-state-disabled");
      }

      $("<span>", {
        style: item.element.attr("data-style"),
        "class": "ui-icon " + item.element.attr("data-class")
      }) 
      .appendTo(wrapper);

      return li.append(wrapper).appendTo(ul);
    } 
  });

  $("#languages")
  .iconselectmenu()
  .iconselectmenu("menuWidget")
  .addClass("ui-menu-icons customicons");

  $( "#languages" ).on('iconselectmenuchange', function() {
    var option = this.value;
     setLang(option);
   
  });
  
  let lang=window.localStorage.getItem('lexp.clarin-pl.eu.lang');
  
  $("#languages-button .ui-selectmenu-text").html("  ");
  console.log($("#languages-button .ui-selectmenu-text").get()[0])
  setLang(lang);
  
  function setLang(option)
  { //console.log(option);
    window.localStorage.setItem('lexp.clarin-pl.eu.lang', option); 
    $( "#languages" ).val(option).change();
    //console.log("val"+$( "#languages" ).val()); 
    switch(option) {
      case 'lang-pl':
        document.body.className = 'pl';
        document.body.lang = 'pl';
        
        $('#languages-button').css('background-image', 'url("/img/lang-pl-32.png")');
        break;
      case 'lang-en':
        document.body.className = 'en';
        document.body.lang = 'en';
        $('#languages-button').css('background-image', 'url("/img/lang-en-32.png")');
        
        break;
      case 'lang-de':
        document.body.className = 'de';
        document.body.lang = 'de';
        break;
      case 'lang-hu':
        document.body.className = 'hu';
        document.body.lang = 'hu';
        break;
      case 'lang-es':
        document.body.className = 'es';
        document.body.lang = 'es';
        break;
      case 'lang-ru':
        document.body.className = 'ru';
        document.body.lang = 'ru';
        break;
      default:
        setLang('lang-pl') 
    }
  };

});