var Lexp = new Object();

Lexp.localHref = function(event) {
  var target = this.getAttribute("href");
  Lexp.target = this.getAttribute("source");
  Lexp.go2URL(target);

  return false;
}

Lexp.showIndexResults = function (results) {
  $(Lexp.lexp_placeholder).html("");

  for(var _result in results.results) {
    var _res = new Resource(_result, results.results[_result], $(Lexp.lexp_placeholder), Lexp);
    /*console.log("ID:::");
    console.log(_result);
    console.log("INFO DATA:::");
    console.log(results.results[_result]);
    console.log("TAG:::");
    console.log($(Lexp.lexp_placeholder));
    console.log("LEXP:::");
    console.log(Lexp);*/
    Lexp.lexpResources[_result] = _res;
    if (_result == Lexp.target) {
      _res.element.show();
      var arrow = $('#lexpresource_' + _result).find('.arrow');
      if(_res.element.state == "hidden" || _res.element.state == "empty") {
        $(arrow[0]).removeClass("glyphicon-chevron-up");
        $(arrow[0]).addClass("glyphicon-chevron-down");
      } else {
        $(arrow[0]).removeClass("glyphicon-chevron-down");
        $(arrow[0]).addClass("glyphicon-chevron-up");
      }
    }
    if (Object.keys(results.results).length == 1) {
      _res.element.show();
    }
  }
  Lexp.moveHeaders(['plwordnet', 'morfeusz', 'walenty', 'omwn', 'hask', 'spxvi', 'spxvii', 'eswil', 'word2vec']);
}

Lexp.moveHeaders = function (order) {
  $('#lexp_results .decoration-box').each(function() {
    $(this).remove();
  });

  $(order).each(function(index, element) {
    if ($('#lexpresource_' + element).length > 0) {
      $('#lexpresource_' + element).appendTo('#lexp_results');
      $('#lexpelement_' + element).appendTo('#lexp_results');
      $('<div class="decoration-box"><div class="decoration"></div></div>').appendTo('#lexp_results');
    }
  });
}

Lexp.lexCall = function (task) {
  var _what = "/lexp/";

  //only on lexp-dev page !!!!!!!!!
  task["dev"] = true;

  console.log("_____________________________");
  console.log("  Task: " + JSON.stringify(task));
  $("#result").hide();
  $.ajax({
    type: "POST",
    contentType: 'application/json',
    data: JSON.stringify(task),
    url: _what,
    cache: false,
    processData: false,
    dataType: "json",
    success: function(res) {
      Lexp.urlChange();
      Lexp.showIndexResults(res);
    },
    error:function(jqXHR, exception) {
      nlp_error(jqXHR,exception);
      return;
    }
  });
}

Lexp.lexpResources = new Array();

Lexp.setURL = function() {
  var _stateObj = {foo: "bar"}, _type;

  if(!Lexp.element.type) {
    _type = "orth";
  } else {
    _type = Lexp.element.type;
  }

  var _url = '';
  if (Lexp.element.type == 'synsetid') {
    _url = "/" + Lexp.element.type + "/" + Lexp.element.typeOfSynset + "/" + Lexp.element.val;
  } else {
    _url = "/" + Lexp.element.type + "/" + Lexp.element.lang + "/" + Lexp.element.val;
  }

  history.pushState(_stateObj, "", _url);
}

Lexp.go2URL = function(pathname) {
  let decodedPathName = decodeURIComponent(pathname);
  var _paths = pathname.split("/");
  if (_paths.length < 4) {
    return;
  }
  var _type = _paths[1],
      _lang = _paths[2],
      _typeOfSynset = _paths[2];
  $("#lang").val(_lang);
  var _phrase = decodeURIComponent(_paths[3]);
  $("#phrase").val(_phrase);

  var _element = {"lang" : $("#lang").val()};
      _element[$("#type").val()] = $("#phrase").val();
  var _function = "list",
      _task = {"function" : _function, "element" : _element},
      lang = $("#lang").val(),
      type = $("#type").val(),
      phrase = $("#phrase").val();
  Lexp.element.path = decodedPathName;
  // Lexp.element.lemma = _phrase;
  Lexp.element.type = _type;
  if (_type == 'lemma') {
    delete Lexp.element.synsetid;
    delete Lexp.element.typeOfSynset;
    Lexp.element.lang = _lang;
    Lexp.element.lemma = _phrase;
  }
  if (_type == 'orth') {
    delete Lexp.element.lemma;
    delete Lexp.element.synsetid;
    delete Lexp.element.typeOfSynset;
    Lexp.element.lang = _lang;
    Lexp.element.orth = _phrase;
  }
  if (_type == 'synsetid') {
    delete Lexp.element.lemma;
    Lexp.element.lang = 'pl';
    Lexp.element.synsetid = _phrase;
    Lexp.element.typeOfSynset = _typeOfSynset;
  }
  Lexp.element.val = _phrase;
  Lexp.setURL();
  var _task = {"function" : _function, "element" : Lexp.element};
  Lexp.lexCall(_task);
}

Lexp.init = function(lexp_placeholder) {
  Lexp.lexp_placeholder = lexp_placeholder;
  Lexp.target = "";
  Lexp.element = {'lang' : 'pl', 'lemma' : 'jenerał'};
  var _pathname = window.location.pathname;

  let decodedPathName = decodeURIComponent(_pathname);

  $("#startlex").click(function() {
    var _element = {"lang" : $("#lang").val()};
        _element[$("#type").val()] = $("#phrase").val();
    var _function = "list",
        _task = {"function" : _function, "element" : _element},
        // lang = '',
        lang = $("#lang").val() || 'pl',
        typeOfSynset = $('#type-of-synset').val(),
        type = $("#type").val(),
        phrase = $("#phrase").val();

    // if ($("#lang").val() != null) {
    //   lang = $("#lang").val();
    // } else {
    //   lang = 'pl';
    // }
    Lexp.element = _element;
    Lexp.element.path = decodedPathName;
    Lexp.element.type = type;
    // Lexp.element.lang = lang;
    if ($('#lang').is(':visible')) {
      Lexp.element.lang = lang;
      delete Lexp.element.synsetid;
      delete Lexp.element.typeOfSynset;
    }
    if ($('#type-of-synset').is(':visible')) {
      // delete Lexp.element.lang;
      delete Lexp.element.lemma;
      Lexp.element.synsetid = phrase;
      Lexp.element.typeOfSynset = typeOfSynset;
    }
    Lexp.element.val = phrase;
    Lexp.setURL();
    Lexp.lexCall(_task);

    return false;
  });
  if (_pathname != '/') {
    Lexp.go2URL(_pathname);
  }
}

Lexp.urlChange = function() {
  // Language
  if (window.location.href.indexOf("/pl/") > -1) {
    $('#lang').val("pl");
  } else if (window.location.href.indexOf("/en/") > -1) {
    $('#lang').val("en");
  } else if (window.location.href.indexOf("/es/") > -1) {
    $('#lang').val("es");
  }

  // Type of element
  if (window.location.href.indexOf("/lemma/") > -1) {
    $('#lang-box').show();
    $('#synset-box').hide();
    $('#type').val("lemma");
  } else if (window.location.href.indexOf("/orth/") > -1) {
    $('#lang-box').show();
    $('#synset-box').hide();
    $('#type').val("orth");
  } else if (window.location.href.indexOf("/synsetid/") > -1) {
    $('#lang-box').hide();
    $('#synset-box').show();
    $('#type').val("synsetid");
  } else {
    $('#type').val("lemma");
  }
}