$(function() {
  var typeOfElementSelectData = new Object();

  typeOfElementSelectData.selectID = 'type';
  typeOfElementSelectData.value = ['lemma', 'orth', 'synsetid'];
  typeOfElementSelectData.text = {
    'pl': ['Forma bazowa', 'Forma wyrazowa', 'Identyfikator synsetu'],
    'en': ['Base form', 'Word form', 'Synset id']
  };

  var typeOfElementSelectDataString = JSON.stringify(typeOfElementSelectData),
      typeOfElementSelect = JSON.parse(typeOfElementSelectDataString);

  var languageSelectData = new Object();

  languageSelectData.selectID = 'lang';
  languageSelectData.value = ['pl', 'en', 'es'];
  languageSelectData.text = {
    'pl': ['Polski', 'Angielski', 'Hiszpański'],
    'en': ['Polish', 'English', 'Spanish']
  };

  var languageSelectDataString = JSON.stringify(languageSelectData),
      languageSelect = JSON.parse(languageSelectDataString);

  var typeOfSynsetSelectData = new Object();

  typeOfSynsetSelectData.selectID = 'type-of-synset';
  typeOfSynsetSelectData.value = ['plwordnet'];
  typeOfSynsetSelectData.text = {
    'pl': ['plWordnet'],
    'en': ['plWordnet']
  };

  var typeOfSynsetSelectDataString = JSON.stringify(typeOfSynsetSelectData),
      typeOfSynsetSelect = JSON.parse(typeOfSynsetSelectDataString);

  appSelect.fulfillmentOfSelect(typeOfElementSelect);
  appSelect.fulfillmentOfSelect(languageSelect);
  appSelect.fulfillmentOfSelect(typeOfSynsetSelect);

  $( "#languages" ).on('iconselectmenuchange', function() {
    appSelect.fulfillmentOfSelect(typeOfElementSelect);
    appSelect.fulfillmentOfSelect(languageSelect);
    appSelect.fulfillmentOfSelect(typeOfSynsetSelect);
  });

});